#include <STC8.H>
#include <intrins.h>
#include <string.h>
#define		DATA	P30		//
#define		CLOCK	P31		//	
#define		ADDR_A	P32		//
#define		ADDR_B	P33		//
#define		LATCH	P34		//	
#define		ENABLE	P35		//
unsigned char Offset_Bit,Offset_String;
unsigned char code String[]=
{
	#include <0.h>
};

/*----------------------------ʱ10us@STC-Y6@11.0592MHz----------------------------*/
void Delay_10us(void)
{
	unsigned char i;
	i=35;
	while(--i);
}

/*----------------------------ʱx10us----------------------------*/
void Delay_x10us(unsigned char x)
{
	while(x--)
		Delay_10us();
}

void Line_Driver(unsigned char line)
{
	ADDR_A=line%2;
	ADDR_B=line/2;
}

void Send_One_Byte(unsigned char temp)
{
	unsigned char i,temp1;
	for(i=0;i<8;i++)
	{
		temp1<<=1;
		if(temp&0x01)
			temp1|=0x01;
		temp>>=1;
	}
	SBUF=temp1;
	while(!TI);
	TI=0;
}

void Send_Display(unsigned char line)
{
	unsigned char i,j,a,b;
	unsigned int c,d;
	b=2*line;
	for(i=0;i<4;i++)
	{
		c=(Offset_String+i)*32;
		for(j=0;j<8;j++)
		{
//			if(j<4)
			if(j==0||j==1||j==4||j==5)
			{
//				a=(3-j)*8;
				if(j==0)
					a=24;
				if(j==1)
					a=16;
				if(j==4)
					a=8;
				if(j==5)
					a=0;
				d=a+b+c;
				if(Offset_Bit<=8)
					Send_One_Byte((String[d]<<Offset_Bit)|(String[d+1])>>(8-Offset_Bit));
				else
					Send_One_Byte((String[d+1]<<(Offset_Bit-8))|(String[d+32])>>(8-(Offset_Bit-8)));
			}
			else
			{
//				a=(7-j)*8;
				if(j==2)
					a=24;
				if(j==3)
					a=16;
				if(j==6)
					a=8;
				if(j==7)
					a=0;
				d=a+b+c;
				if(Offset_Bit<=8)
					Send_One_Byte((String[d+1]<<Offset_Bit)|(String[d+32])>>(8-Offset_Bit));
				else
					Send_One_Byte((String[d+32]<<(Offset_Bit-8))|(String[d+33])>>(8-(Offset_Bit-8)));
			}
		}
	}
	LATCH=0;
	LATCH=1;
}

void Display(unsigned char brightness)
{
	unsigned char line;
	for(line=0;line<4;line++)
	{
		Send_Display(line);
		Line_Driver(line);
		ENABLE=1;
		Delay_x10us(brightness);
		ENABLE=0;
		Delay_x10us(10-brightness);
	}
}

void Init(void)
{
	AUXR|=0x20;
	P3M0=0x3f;
	P3M1=0x00;
	Offset_Bit=0;
	Offset_String=0;
}

void main(void)
{
	unsigned char i;
	Init();
	while(1)
	{
		for(i=0;i<10;i++)
		{
			Display(5);
		}
		Offset_Bit++;
		if(Offset_Bit==16)
		{
			Offset_Bit=0;
			Offset_String++;
		}
		if(Offset_String==160)
		{
			Offset_String=0;
		}
	}
}